From 9493baa1b34e1e9b77cc5e4bc2c3c257fc0b9de4 Mon Sep 17 00:00:00 2001
From: ssnf <ssnf@ssnf.xyz>
Date: Mon, 25 Oct 2021 13:35:44 +0000
Subject: [PATCH] Remove all trailing white space during the save operation

---
 sim.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/sim.c b/sim.c
index d025fce..910625e 100644
--- a/sim.c
+++ b/sim.c
@@ -565,6 +565,7 @@ static void
 file_save(int arg)
 {
 	FILE* disk;
+	Posn  p, q;
 
 	if (arg == -1)
 		arg = f - file;
@@ -573,6 +574,13 @@ file_save(int arg)
 		if (!file[arg].name->n)
 			return;
 	}
+	for (p = f->s->n - 1; p; --p) {
+		if (f->s->s[p] == '\n') {
+			for (q = p; q - 1 > 0 && (f->s->s[q - 1] == ' ' || f->s->s[q - 1] == '\t'); --q);
+			if (q != p)
+				str_delete(f->s, q, p);
+		}
+	}
 	disk = fopen(file[arg].name->s, "w");
 	fwrite(file[arg].s->s, file[arg].s->n, 1, disk);
 	fclose(disk);
-- 
2.33.1

